-- Vhdl test bench created from schematic C:\Users\YNemoto\Documents\FPGA\gear2015b\top.sch - Sun Sep 20 13:50:05 2015
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY top_top_sch_tb IS
END top_top_sch_tb;
ARCHITECTURE behavioral OF top_top_sch_tb IS 

   COMPONENT top
   PORT( CLK	:	IN	STD_LOGIC;
          TX	:	OUT	STD_LOGIC; 
          RX	:	IN	STD_LOGIC; 
          SPI_CS	:	IN	STD_LOGIC; 
          SPI_MOSI	:	IN	STD_LOGIC; 
          SPI_CLK	:	IN	STD_LOGIC; 
          SPI_MISO	:	OUT	STD_LOGIC;
			 FLASH_CK : OUT STD_LOGIC;
			 FLASH_CS : OUT STD_LOGIC;
			 FLASH_SO : IN STD_LOGIC;
			 FLASH_SI : OUT STD_LOGIC;
          LED1	:	OUT	STD_LOGIC);
   END COMPONENT;
	 
	constant CYCLE	: Time := 32 ns;
	constant HALF_CYCLE	: Time := 16 ns;

   SIGNAL CLK	:	STD_LOGIC;
   SIGNAL TX	:	STD_LOGIC;
   SIGNAL RX	:	STD_LOGIC;
   SIGNAL SPI_CS	:	STD_LOGIC;
   SIGNAL SPI_MOSI	:	STD_LOGIC;
   SIGNAL SPI_CLK	:	STD_LOGIC;
   SIGNAL SPI_MISO	:	STD_LOGIC;
   SIGNAL LED1	:	STD_LOGIC;
   SIGNAL FLASH_CK	:	STD_LOGIC;
   SIGNAL FLASH_CS	:	STD_LOGIC;
   SIGNAL FLASH_SO	:	STD_LOGIC;
   SIGNAL FLASH_SI	:	STD_LOGIC;


	--SIGNAL ADDR : STD_LOGIC_VECTOR (15 downto 0);

BEGIN

   UUT: top PORT MAP(
		CLK => CLK, 
		TX => TX, 
		RX => RX, 
		SPI_CS => SPI_CS, 
		SPI_MOSI => SPI_MOSI, 
		SPI_CLK => SPI_CLK, 
		SPI_MISO => SPI_MISO, 
		LED1 => LED1,
		FLASH_CK => FLASH_CK,
		FLASH_CS => FLASH_CS,
		FLASH_SO => FLASH_SO,
		FLASH_SI => FLASH_SI
   );



-- *** Test Bench - User Defined Section ***
	process begin
		CLK <= '1';
		wait for HALF_CYCLE;
		CLK <= '0';
		wait for HALF_CYCLE;
	end process;

	process begin
		SPI_CLK <= '1';
		wait for HALF_CYCLE*8;
		SPI_CLK <= '0';
		wait for HALF_CYCLE*8;
	end process;

   tb : PROCESS
   BEGIN
		wait for CYCLE*1000;
      WAIT; -- will wait forever
   END PROCESS;
END;


configuration COUNTER_TEST OF top_top_sch_tb IS
for behavioral end for;
end COUNTER_TEST;
