----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    01:14:18 09/20/2015 
-- Design Name: 
-- Module Name:    myclock - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity myclock is
    Port ( clk_in : in  STD_LOGIC;
           reset_out : out  STD_LOGIC;
           clk_thru : out  STD_LOGIC;
           clk_8m : out  STD_LOGIC;
           clk4m : out  STD_LOGIC;
           clk2m : out  STD_LOGIC;
			  MCU_clk_posedge : out  STD_LOGIC);
end myclock;

architecture Behavioral of myclock is

signal counter : STD_LOGIC_VECTOR(3 downto 0) := (others => '0');
signal reset_counter : STD_LOGIC_VECTOR(4 downto 0) := (others => '0');

begin
	clk_thru <= clk_in;
	clk_8m <= counter(1);
	clk4m <= counter(2);
	clk2m <= counter(3);
	reset_out <= '0' when reset_counter="10000" else '1';
	MCU_clk_posedge <= '1' when counter(3 downto 0)="1010" else '0';	--CPU_CLOCK=clk2m

	process (clk_in)
	begin
		if rising_edge(clk_in) then
			counter <= counter+1;
			if (reset_counter /="10000") then
				reset_counter <= reset_counter+1;
			end if;
		end if;
	end process;

end Behavioral;

