----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    00:24:02 05/23/2015 
-- Design Name: 
-- Module Name:    vdp9918render - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity vdp9918render is
    Port ( VDP_ENA : in  STD_LOGIC;
           LCD_DATA_IN : in  STD_LOGIC_VECTOR (19 downto 0);
           LCD_DATAC : out  STD_LOGIC_VECTOR (15 downto 0);
			  LCD_DATAB : out  STD_LOGIC_VECTOR (15 downto 0);
           clkv : in  STD_LOGIC;
           VRAM_A : out  STD_LOGIC_VECTOR (13 downto 0);
           VRAM_D : in  STD_LOGIC_VECTOR (7 downto 0);
			  VRAM_WR : out  STD_LOGIC;
           VRAM_CPU_A : out  STD_LOGIC_VECTOR (13 downto 0);
			  VRAM_CPU_WR : out  STD_LOGIC;
			  CPU_Din : in  STD_LOGIC_VECTOR (7 downto 0);
			  CPU_Dout : out  STD_LOGIC_VECTOR (7 downto 0);
           FBUF_A : out  STD_LOGIC_VECTOR (15 downto 0);
           FBUF_Din : in  STD_LOGIC_VECTOR (3 downto 0);
           FBUF_Dout : out  STD_LOGIC_VECTOR (3 downto 0);
           FBUF_W : out  STD_LOGIC;
			  CS_VDP : out STD_LOGIC;
			  TESTREG : in  STD_LOGIC_VECTOR (15 downto 0);
			  CS_VRAM : out STD_LOGIC;
				PORT0_RD : in  STD_LOGIC;
				PORT1_RD : in  STD_LOGIC;
				PORT0_WR : in  STD_LOGIC;
				PORT1_WR : in  STD_LOGIC;
			  IRQ_out : out STD_LOGIC);
end vdp9918render;

architecture Behavioral of vdp9918render is
	signal fc_counter : STD_LOGIC_VECTOR(19 downto 0) := (others => '0');
	signal y_counter : STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
	signal x_counter : STD_LOGIC_VECTOR(8 downto 0) := (others => '0');
	signal ya_counter : STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
	signal xa_counter : STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
	signal xas_counter : STD_LOGIC_VECTOR(2 downto 0) := (others => '0');
	signal yas_counter : STD_LOGIC_VECTOR(2 downto 0) := (others => '0');
	signal clk_counter : STD_LOGIC_VECTOR(2 downto 0) := (others => '0');
	signal vState : STD_LOGIC_VECTOR(1 downto 0);
	signal cdata : STD_LOGIC_VECTOR(15 downto 0);
	signal colCode : STD_LOGIC_VECTOR(3 downto 0);
	signal rState : STD_LOGIC_VECTOR(4 downto 0) := (others => '0');
	signal bShift : STD_LOGIC;
	signal n_reg : STD_LOGIC_VECTOR(7 downto 0);
	signal bit_reg : STD_LOGIC_VECTOR(7 downto 0);
	signal col_reg : STD_LOGIC_VECTOR(7 downto 0);
	signal sp_gen_reg_h : STD_LOGIC_VECTOR(8 downto 0);
	signal sp_gen_reg_l : STD_LOGIC_VECTOR(3 downto 0);
	signal sp_count : STD_LOGIC_VECTOR(4 downto 0);
	signal sp_x_count : STD_LOGIC_VECTOR(3 downto 0);
	signal sp_y_count : STD_LOGIC_VECTOR(3 downto 0);
	signal sp_x_reg : STD_LOGIC_VECTOR(8 downto 0);
	signal io_status : STD_LOGIC := '0';
	signal io_reg : STD_LOGIC_VECTOR(7 downto 0);
	signal io_vram_addr : STD_LOGIC_VECTOR(13 downto 0);
	
	signal vdpr_m2 : STD_LOGIC := '0';
	signal vdpr_bl : STD_LOGIC := '0';
	signal vdpr_gint : STD_LOGIC := '0';
	signal vdpr_m1 : STD_LOGIC := '0';
	signal vdpr_m3 : STD_LOGIC := '0';
	signal vdpr_si : STD_LOGIC := '0';
	signal vdpr_mag : STD_LOGIC := '0';
	signal vdpr_pn : STD_LOGIC_VECTOR(3 downto 0) := "1110";
	signal vdpr_ct : STD_LOGIC_VECTOR(7 downto 0) := "00000000";
	signal vdpr_pg : STD_LOGIC_VECTOR(2 downto 0) := "100";
	signal vdpr_sa : STD_LOGIC_VECTOR(6 downto 0) := "1110110";
	signal vdpr_sg : STD_LOGIC_VECTOR(2 downto 0) := "011";
	signal vdpr_status_int : STD_LOGIC;
	signal irqstate : STD_LOGIC_VECTOR(2 downto 0) := (others => '0');

   signal LCD_WR : STD_LOGIC;
   signal LCD_RS : STD_LOGIC;
	signal vdp_cs0 : STD_LOGIC;
	signal vdp_cs1 : STD_LOGIC;
	signal mcu_io_state : STD_LOGIC_VECTOR(2 downto 0) := (others => '0');
	signal iocnt : STD_LOGIC := '0';
	
	signal testbit : STD_LOGIC;
	signal testbits : STD_LOGIC;
	signal selecter : STD_LOGIC_VECTOR(3 downto 0);
	
	signal datab_internal : STD_LOGIC_VECTOR(15 downto 0);
	signal datab_external : STD_LOGIC_VECTOR(15 downto 0);
	
begin
	
	LCD_RS <= '1';
	VRAM_WR <= '0';	--read only
	selecter <= PORT0_RD & PORT0_WR & PORT1_RD & PORT1_WR;
	--colCode <= FBUF_Din(3 downto 0);
	colCode <= FBUF_Din(3 downto 0) when (testbit='0') else "1000";

	LCD_DATAC <= cdata when (VDP_ENA='1') else LCD_DATA_IN(15 downto 0);
	datab_internal <= "00000000000" & '1' & '1' & LCD_WR & LCD_RS & '0';
	datab_external <= "00000000000" & LCD_DATA_IN(18) & '1' & LCD_DATA_IN(17) & LCD_DATA_IN(16) & '0';
	LCD_DATAB <= datab_internal when (VDP_ENA='1') else datab_external;

	VRAM_CPU_WR <= '1' when (mcu_io_state="001") else '0';
	VRAM_CPU_A <= io_vram_addr;
	vdp_cs0 <= PORT0_RD or PORT0_WR;
	vdp_cs1 <= PORT1_RD or PORT1_WR;
	CPU_Dout <= vdpr_status_int & "0000000";
	CS_VRAM <= vdp_cs0;
	CS_VDP <=  vdp_cs1;
	vdpr_status_int <= '1' when (irqstate="001") else '0';
	IRQ_out <= vdpr_status_int and vdpr_gint;
	--IRQ_out <=vdpr_status_int;
	
	
	-- MCU I/O
	
	process(clkv,PORT1_WR,PORT0_WR,PORT0_RD,iocnt,io_reg,CPU_Din,mcu_io_state)
	begin
		if rising_edge(clkv) then
			case mcu_io_state is
				when"000"=>
					if (PORT0_WR='1') then	--98H Write
						mcu_io_state<="001";
					end if;
					if (PORT0_RD='1') then	--98H Read
						mcu_io_state<="010";
					end if;
					if (PORT1_WR='1' and iocnt='0') then	--99H Write0
						io_reg <= CPU_Din;
						ioCnt<='1';
						mcu_io_state<="111";
					end if;
					if (PORT1_WR='1' and iocnt='1') then	--99H Write1
						if (CPU_Din(7 downto 6) = "00" ) then
							io_vram_addr <= CPU_Din(5 downto 0) & io_reg;
						end if;
						if (CPU_Din(7 downto 6) = "01" ) then
							io_vram_addr <= CPU_Din(5 downto 0) & io_reg;
						end if;
						if (CPU_Din(7 downto 6) = "10" ) then
							case CPU_Din(2 downto 0) is
								when "000" => vdpr_m2 <= io_reg(1);
								when "001" =>
										vdpr_bl <=io_reg(6);
										vdpr_gint <= io_reg(5);
										vdpr_m1 <= io_reg(4);
										vdpr_m3 <= io_reg(3);
										vdpr_si <= io_reg(1);
										vdpr_mag <= io_reg(0);
								when "010" => vdpr_pn <= io_reg(3 downto 0);
								when "011" => vdpr_ct <= io_reg(7 downto 0);
								when "100" => vdpr_pg <= io_reg(2 downto 0);
								when "101" => vdpr_sa <= io_reg(6 downto 0);
								when "110" => vdpr_sg <= io_reg(2 downto 0);
								when others => vdpr_sg <= vdpr_sg;	--dummy
							end case;
						end if;
						ioCnt<='0';
						mcu_io_state<="111";
					end if;
				when"001"=>
					mcu_io_state<="011";
				when"010"=>
					mcu_io_state<="011";
				when"011"=>
					mcu_io_state<="110";
				when"110"=>
					if (selecter="0000") then
					io_vram_addr<=io_vram_addr+1;
						mcu_io_state<="000";
					end if;
				when"111"=>
					if (selecter="0000") then
						mcu_io_state<="000";
					end if;
				when others=>
					mcu_io_state<="000";
				end case;
		end if;
	end process;
	

	process(clkv,irqstate,x_counter,PORT1_RD)
   begin
		if rising_edge(clkv) then
		case irqstate is
			when"000" =>
				if ( rState = "10111" ) then
					irqstate <= "001";
				end if;
			when"001"=>
				if (PORT1_RD='1') then
					irqstate <= "010";
				end if;
			when"010"=>
				if (rState /= "10111" ) then
					irqstate <= "000";
				end if;
			when others =>
				irqstate <= "000";
		end case;
		end if;
	end process;



	count: process(clkv)
   begin
	if rising_edge(clkv) then
		clk_counter <= clk_counter + 1;
		if (fc_counter="10000010110111001101") then
			fc_counter <= (others=>'0');
		else
			fc_counter <= fc_counter +1;
		end if;
		case rState is
		when "00000" =>
			if (VDP_ENA='1') then
				rState <= rState +1;
			end if;
		when "00001" =>
			if (fc_counter="00000000000000000001") then
				rState <= rState +1;
			end if;
			x_counter <= "000000000";
			y_counter <= "00000000";
			xa_counter <= "11111111";
			ya_counter <= "00000000";
			xas_counter <="000";
			yas_counter <="000";
		when "00010" =>
			rState <= rState +1;
		when "00011" =>
			if ((vdpr_m1='0') and(vdpr_m2='0') and(vdpr_m3='0')) then
				rState <="11000";
			else
				rState <= rState +1;
			end if;
			n_reg <= VRAM_D;
		when "00100" =>
			rState <= rState +1;
		when "00101" =>
			rState <= rState +1;
			bit_reg <= VRAM_D;
		when "00110" =>
			rState <= rState +1;
			col_reg <= VRAM_D;
		when "00111"|"01000"|"01001"|"01010"|"01011"|"01100"|"01101" =>
			bit_reg <= bit_reg(6 downto 0) & '0';
			x_counter <= x_counter + 1;
			rState <= rState +1;
		when "01110" =>
			bit_reg <= bit_reg(6 downto 0) & '0';
			x_counter <= x_counter + 1;
			if ( x_counter >= "100000000" ) then
				if ( y_counter = "10111111" ) then
					sp_count <= "00000";
					rState <= "11010";
				else
					x_counter <= "000000000";
					y_counter <= y_counter+1;
					rState <= "00010";
				end if;
			else
				rState <= "00010";
			end if;

	-- SPRITE
		when "11010" =>
			if (sp_count="11111") then
				rState <= "01111"; else
				if ((sp_count /= "00000") and (VRAM_D="11010000")) then
					rState <= "01111";
				else
					sp_count <= sp_count+1;
				end if;
			end if;
		when "01111" =>
			rState <= rState +1;
		when "10000" =>
			rState <= rState +1;
			y_counter <= VRAM_D;
		when "10001" =>
			sp_x_reg <= '0' & VRAM_D;
			if (y_counter = "11010000" ) then	--208(0xdo) sprite terminate
				rState <= "10110";
			else
				rState <= rState +1;
			end if;
		when "10010" =>
			rState <= rState +1;
			sp_gen_reg_h <= vdpr_sg & VRAM_D(7 downto 2);
			sp_gen_reg_l <= "0000";
		when "10011" =>
			rState <= rState +1;
			col_reg <= VRAM_D;
			if (VRAM_D(7) = '1' ) then
				sp_x_reg <= sp_x_reg - 32;
			end if;
		when "10100" =>
			rState <= rState +1;
			bit_reg <= VRAM_D;
			sp_x_count <= "0000";
			sp_y_count <= "0000";
			x_counter <= sp_x_reg;
		when "10101" =>
			sp_x_count <= sp_x_count +1;
			if (sp_x_count = "0111") then
				bit_reg <= VRAM_D;
				sp_gen_reg_l <= sp_gen_reg_l+1;
			end if;
			if (sp_x_count = "1111") then
				if (sp_y_count="1111" ) then
					rState <= rState +1;
				else
					bit_reg <= VRAM_D;
					sp_y_count <= sp_y_count +1;
					y_counter <= y_counter +1;
					x_counter <= sp_x_reg;
				end if;
			else
				x_counter <= x_counter+1;
			end if;
			if ( sp_x_count(2 downto 0) /= "111" ) then
				bit_reg <= bit_reg(6 downto 0) & '0';
			end if;
		when "10110" =>
			if (sp_count = "00000" ) then	--how many sprites
				rState <= rState +1;
				x_counter <= "100111111";
				clk_counter <= "000";
				y_counter <= "00000000";
			else
				sp_count <= sp_count -1;
				rState <= "01111";
			end if;
	-- to LCD
		
		when "10111" =>
			if (clk_counter(1 downto 0) = "00" ) then
				if (y_counter = "11101111" ) then
					y_counter <= "00000000";
					ya_counter <= "00000000";
					yas_counter <= "000";
					if (x_counter = "000000000" ) then
						if (VDP_ENA = '1' ) then
							rState <= "00001";
						else
							rState <= "00000";
						end if;
					else
						x_counter <= x_counter -1;
						if (xas_counter="100") then xas_counter <="000";
							else xas_counter <= xas_counter+1; xa_counter <= xa_counter -1;
						end if;
					end if;
				else
					y_counter <= y_counter +1;
						if (yas_counter="100") then yas_counter <="000";
							else yas_counter <= yas_counter+1; ya_counter <= ya_counter +1;
						end if;
				end if;
			end if;

	-- SCREEN1(MODE 0)
		when "11000" =>
			rState <= rState+1;
		when "11001" =>
			rState <= "00110";
			bit_reg <= VRAM_D;
		when others =>
		end case;
	end if;


   end process;
	
	process(rState,x_counter,y_counter,bit_reg,clk_counter,vdpr_pn,vdpr_ct,col_reg,vdpr_sa,vdpr_pg,n_reg,sp_count,sp_gen_reg_h)
	begin
		case rState is
		when "00000" =>
				FBUF_A <= (others => 'X');
				FBUF_W <= '0';
				FBUF_Dout <= (others => 'X');
				VRAM_A  <= (others => 'X');
		when "00001" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= (others => 'X');
		when "00010" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= vdpr_pn & y_counter(7 downto 3) & x_counter(7 downto 3);
		when "00011" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= (others => 'X');
		when "00100" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= vdpr_pg(2) & y_counter(7 downto 6) & n_reg(7 downto 0) & y_counter(2 downto 0);	--bit
		when "00101" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= vdpr_ct(7) & y_counter(7 downto 6) & n_reg(7 downto 0) & y_counter(2 downto 0);	--col
		when "00110" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= (others => 'X');
		when "00111"|"01000"| "01001"|"01010"|"01011"|"01100"|"01101"|"01110" =>
			FBUF_A <= y_counter(7 downto 0) & x_counter(7 downto 0);
			FBUF_W <= '1';
			if (bit_reg(7)='1') then
				FBUF_Dout <= col_reg(7 downto 4);
				else
				FBUF_Dout <= col_reg(3 downto 0);
			end if;
			VRAM_A  <= (others => 'X');
	-- SPRITE
		when "11010" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= vdpr_sa & sp_count & "00";
		when "01111" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= vdpr_sa & sp_count & "00";
		when "10000" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= vdpr_sa & sp_count & "01";
		when "10001" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= vdpr_sa & sp_count & "10";
		when "10010" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= vdpr_sa & sp_count & "11";
		when "10011"|"10100"| "10101"|"10110" =>
			FBUF_A <= y_counter(7 downto 0) & x_counter(7 downto 0);
			FBUF_Dout <= col_reg(3 downto 0);
			VRAM_A  <= sp_gen_reg_h & ( sp_x_count(3) xor '1' ) & sp_gen_reg_l; 
			if ( (bit_reg(7)='1') and (y_counter <"11000000") and (x_counter(8)='0')) then
				FBUF_W <= '1';
				else
				FBUF_W <= '0';
			end if;
	-- FBUF to LCD
		when "10111" =>
			FBUF_A <= ya_counter(7 downto 0) & xa_counter(7 downto 0);
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= (others => 'X');



		-- SCREEN 1(MODE 0)
		when "11000" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= vdpr_pg(2 downto 0) & n_reg(7 downto 0) & y_counter(2 downto 0);	--bit
		when "11001" =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= vdpr_ct & '0' & n_reg(7 downto 3);	--col
		when others =>
			FBUF_A <= (others => 'X');
			FBUF_W <= '0';
			FBUF_Dout <= (others => 'X');
			VRAM_A  <= (others => 'X');
		end case;


		if ( rState = "10111" ) then
			LCD_WR <= clk_counter(1);
		else
			LCD_WR <= '1';
		end if;
	end process;

	
	process (colCode)
		variable iaddr : integer;
		type rom_type is array (0 to 15) of std_logic_vector(15 downto 0);
		constant rom_table : rom_type :=(
			"0000000000000000",	--0
			"0000000000000000", --1
			"0100111011000100", --2
			"0110111111101101", --3
			"0010000100111111", --4
			"0100101101111111", --5
			"1011000100100100", --6
			"0100111011011111", --7
			"1111100100100100", --8
			"1111101101101101", --9
			"1101111011000100", --a
			"1101111011010010", --b
			"0010010010000100", --c
			"1101101001010110", --d
			"1011010110110110", --e
			"1111111111111111"); --f
		begin
			iaddr := conv_integer(unsigned(colCode));
			cdata <= rom_table(iaddr);
   end process;


end Behavioral;

