#target bin

#code CODE,$0000
;
;zasm <thisfile> -o  <output path>/monitor.bin
	DI
	IM 1
	LD SP,07F0H

	;注 この辺はまだDRAM初期化中なので正常にアクセスできない模様
	LD C,22H
	LD A,1
	OUT (C),A
	
	LD A,0FFH	;BREAKPOINT=07FFFH
	LD C,023H
	OUT (C),A
	LD A,07FH
	INC C
	OUT (C),A

	LD C,029H
	LD A,001H
	OUT (C),A	;cs=inactive
	
	
	;LD C,28H
	;LD A,0A9H
	;OUT (C),A

	LD HL,str_prompt
	CALL PRINT
	
	;MSXを自動起動　コメントアウトするとモニタへ
	JP SETMSX
	
XJ00:
	LD HL,3800H
	LD B,128
	LD A,32
XJ01:
	CALL VPOKE
	INC A
	INC HL
	DJNZ XJ01
	


PROMPT:
	LD D,'>'
	CALL sendchar
	LD HL,STR_COM
	LD E,0
PJ1:
	CALL get_c_char
	CP 32
	CALL NC,PJ2
	CP 13
	JP Z,EXECUTE
	CP 8
	CALL Z,BACKSPACE
PJ3:
	LD D,A
	CALL sendchar
	JP PJ1
PJ2:
	LD D,A
	LD A,E
	CP 24
	LD A,0
	RET NC
	LD A,D
	LD (HL),A
	INC HL
	INC E
	RET
BACKSPACE:
	DEC HL
	RET

EXECUTE:
	LD (HL),0
	CALL SENDCRLF
	LD HL,STR_COM
	LD A,(HL)
	CP 'D'
	JP NZ,EX1
	CALL HEXVAL
	CALL DUMP
	JP PROMPT
EX1:	CP 'X'
	JP NZ,EX2
	CALL TESTWRITE
	JP PROMPT
EX2:
	CP 'S'
	JP NZ,EX3
	CALL SPIDUMP
	JP PROMPT
EX3:	CP 'R'
	JP NZ,EX4
	JP SETMSX
EX4:	CP 'G'
	JP NZ,EX5
	CALL HEXVAL
	LD C,025H
	OUT (C),H
	LD HL,STR_ACK
	CALL PRINT	
	JP PROMPT
EX5:
	CP 'K'
	JP NZ,EX6
	CALL HEXVAL
	LD C,023H
	OUT (C),L
	INC C
	OUT (C),H
	LD HL,str_bpset
	CALL PRINT
	JP PROMPT
EX6:	CALL SENDCRLF
	JP PROMPT
;==============================
;SUB
;==============================	
PRINT:
	LD A,(HL)
	OR A
	RET Z
	LD D,A
	CALL sendchar
	INC HL
	JP PRINT
sendchar:
	LD C,20H
	IN A,(C)
	AND 08H
	JP Z,sendchar
	LD C,21H
	OUT (C),D
	RET
	
getchar:
	LD C,20H
	IN A,(C)
	AND 1
	RET Z
	LD C,3FH
	IN A,(C)
	RET
get_c_char:
	CALL getchar
	OR A
	JP Z,get_c_char
	RET

SENDCRLF:
	PUSH DE
	PUSH BC
	PUSH AF
	LD D,13
	CALL sendchar
	LD D,10
	CALL sendchar
	POP AF
	POP BC
	POP DE
	RET

TESTWRITE:
	LD HL,4000H
	LD B,128
	LD A,0
TW1:
	LD (HL),A
	INC A
	INC HL
	DJNZ TW1
	LD HL,STR_ACK
	CALL PRINT
	RET
SPIDUMP_S:
	LD C,029H
	LD A,000H
	OUT (C),A	;cs=active

	LD A,0
	LD C,028H
	LD A,00BH
	OUT (C),A	;command
	LD C,028H
	LD A,005H	;bit 23-16
	OUT (C),A
	LD A,032H	;bit15-8
	OUT (C),A
	LD A,06CH	;bit7-0
	OUT (C),A
	LD A,000H
	OUT (C),A	;DUMMY
	
	;==FETCH MAGIC
	LD DE,1000H
SD4:	LD HL,MAGIC
	LD B,8
SD3:	LD C,028H
	DEC DE
	LD A,D
	OR E
	JP Z,SD_ERR
	IN A,(C)
	CP (HL)
	JP NZ,SD4
	INC HL
	DJNZ SD3
	RET	

SPIDUMPSRAM:

	LD C,029H
	LD A,000H
	OUT (C),A	;cs=active

	LD C,028H
	LD A,00BH
	OUT (C),A	;command
	LD C,028H
	LD A,005H	;bit 23-16
	OUT (C),A
	LD A,032H	;bit15-8
	OUT (C),A
	LD A,07CH	;bit7-0
	OUT (C),A
	LD A,000H
	OUT (C),A	;DUMMY

	LD B,128
	LD HL,0680H
SD10:
	LD C,028H
	IN A,(C)
	LD (HL),A
	INC HL
	DJNZ SD10

	LD C,029H
	LD A,001H
	OUT (C),A	;cs=inactive

	LD HL,0680H
	CALL DUMP
	RET

SPIDUMP:
	CALL SPIDUMP_S
	LD B,128
	LD HL,4000H
SD1:
	LD C,028H
	IN A,(C)
	LD (HL),A
	INC HL
	DJNZ SD1

	LD C,029H
	LD A,001H
	OUT (C),A	;cs=inactive

	LD HL,4000H
	CALL DUMP
	RET
SD_ERR:
	LD HL,str_flasherror
	CALL PRINT
	RET

SETMSX:
	CALL SPIDUMP_S
	LD C,025H
	LD A,0
	OUT (C),A
	CALL ONEPAGE
	LD C,025H
	LD A,1
	OUT (C),A
	CALL ONEPAGE
	LD C,025H
	LD A,2
	OUT (C),A
	CALL ONEPAGE
	LD C,025H
	LD A,3
	OUT (C),A
	CALL ONEPAGE
	
	LD C,029H
	LD A,001H
	OUT (C),A	;cs=inactive
	
	LD C,0A8H
	LD A,00H
	OUT (C),A

	LD C,022H
	LD A,07H
	OUT (C),A
	HALT

ONEPAGE:
	LD HL,4000H
	LD DE,4000H
OP1:	LD C,028H
	IN A,(C)
	LD (HL),A
	INC HL
	DEC DE
	LD A,D
	OR E
	JP NZ,OP1
	RET	
;==============================
;DUMP	[E] HL <- START ADDR
;==============================
DUMP:
	LD C,16
DJ2:
	PUSH BC
	LD D,13
	CALL sendchar
	LD D,10
	CALL sendchar
	LD A,H
	CALL PRINTHEX
	LD A,L
	CALL PRINTHEX
	LD D,32
	CALL sendchar
	LD B,8
DJ1:
	LD A,(HL)
	INC HL
	CALL PRINTHEX
	LD D,32
	CALL sendchar
	DJNZ DJ1
	POP BC
	DEC C
	LD A,0
	CP C
	JP NZ,DJ2
	LD D,13
	CALL sendchar
	LD D,10
	CALL sendchar
	RET

PRINTHEX:
	PUSH AF
	SRA A
	SRA A
	SRA A
	SRA A
	AND 0FH
	CP 10
	JP C,PHJ1
	ADD A,7
PHJ1:	ADD A,30H
	LD D,A
	CALL sendchar
	POP AF
	AND 0FH
	CP 10
	JP C,PHJ2
	ADD A,7
PHJ2:	ADD A,30H
	LD D,A
	CALL sendchar
	RET

HEXVAL:
	LD DE,STR_COM
	LD HL,0000
	INC DE
	INC DE
	LD B,4
HV1:
	LD A,(DE)
	CP 'A'
	JP NC,HV4
	SUB '0'
	JP HV3
HV4:
	SUB 'A'
	ADD A,10
HV3:
	ADD HL,HL
	ADD HL,HL
	ADD HL,HL
	ADD HL,HL
	OR L
	LD L,A
	INC DE
	DJNZ HV1
	RET

VPOKE:
	; must be DI
	PUSH BC
	PUSH AF
	LD C,099H
	LD A,L
	
	OUT (C),A
	LD A,H
	OR 40H
	OUT (C),A
	POP AF
	LD C,098H
	OUT (C),A
	
	POP BC
	RET
WRTVDP:
	;Function : write data in the VDP-register
	;Input    : B  - data to write
	;           C  - number of the register
	;Registers: AF, BC
	; must be DI
	LD A,B
	OUT (099H),A
	LD A,C
	OR 80H
	OUT (099H),A
	RET
;==============================
;data
;==============================

str_prompt:
	DB 13,10
	DM "*Z80 MONITOR* ver 2015/09 V0006"
	DB 13,10
	DM "SRAM 0000-07FF / DRAM 4000-7FFF"
	DB 13,10,0	

str_bpset:
	DM "Breakpoint set"
	DB 13,10,0	
str_fail:
	DM "XMODEM failed"
	DB 13,10,0	
str_ok:
	DM "XMODEM recived"
	DB 13,10,0
STR_ACK:
	DM "test done"
	DB 13,10,0
str_flasherror:
	DM "ROM not found"
	DB 13,10,0
MAGIC:
	DB 055H,0AAH,030H,031H,099H,088H,077H,066H
STR_COM:
	DM "                              "
v_receiving:
	DW 0000H
v_buf:
	DW 0000H
v_size:
	DW 0000H
tmpw:
	DW 0000H
#end