/* Name: main.c
 * Author: <insert your name here>
 * Copyright: <insert your copyright message here>
 * License: <insert your license reference here>
 */

//avrdude -p m328p -c avrispmkII -P usb -U flash:w:main.hex:i
//PD1:CS
//PD2:LDAC
//SHDN:Hi

#define F_CPU 8000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

typedef unsigned char byte;

void spi_init(void) ;
void spi_send(unsigned char value);
unsigned char spi_read(unsigned char value);
void spi_sendNoWait(unsigned char value);
unsigned char usartspi_send(unsigned char data);
void setInttrupt(short freq);
void stopBell();
void psg_init();
void psg_test();
void getKeys();
void write_psg(byte reg,byte value);
void test_screen();
void test_screen2();
void spi_chipselect(unsigned char chipselect);
void spi_vdpenable(unsigned char enable);

//
void ILI9325_Initial(void);
void LCD_CtrlWrite_ILI9325(volatile unsigned short index, volatile unsigned short data);
void LCD_IndexWrite_ILI9325(volatile unsigned short index);
void LCD_DataWrite_ILI9325(volatile unsigned short data);
//

byte PSG_REGS[16];
short PSG_COUNT_TOP[4];
short PSG_COUNT[4];
byte gWaveBit;
byte gNoiseMask;
byte gToneMask;
byte iCounter;
byte Zx,Zy;
short gNoiseBit;

byte gTest;

byte gRXSIN;
byte gRXSCOUNT;
byte gPSGR;
byte gRXOUT;

byte keyedge;
byte mcu_clk_mode;
#include "picture.c"
//unsigned short *bmpp;

#define DDR_SPI DDRB
#define DD_MOSI DDB3
#define DD_MISO DDB4
#define DD_SCK DDB5
#define DD_SS DDB2

#define SENDINT PORTB&=0xFE;PORTB|=0x01
#define RX_SIN (PIND&0x80)
#define RX_SOUT1 PORTD |= 0x40
#define RX_SOUT0 PORTD &= 0xBF
#define SYNC_HI PORTD|=0x20
#define SYNC_LOW PORTD&=0xDF

//==============================================
int main(void)
{
    char ri,val;
    byte sl;
    int i;
    /* insert your hardware initialization here */
    CLKPR=0x80;
    CLKPR=0x00;	//set 8MHz 1/1
    spi_init();

    
    DDRC = 0x03;
    PORTC = 0x3F;  //set PULLUP
    DDRB |= 0xc0;    //DA CS,LDAC output
    
    DDRB |= 0x01;    //INT OUT
    DDRD = 0x00;   //PD7-0=IN
    PORTD |= 0xFF;  //set PULLUP(PD7-0)
    
    
    iCounter=0;
    gRXSCOUNT=0;
    gTest=0;
    keyedge=0;
    mcu_clk_mode=1;

    //LCD初期化
    stopIntterupt();
    _delay_ms(1500); // Delay 1500ms
    ILI9325_Initial();
    ILI9325_Initial();
    test_screen();
    spi_vdpenable(1);   //vdp on
    setInttrupt(16667);   //8Mclk 60Hz



    //テスト画面
    for(;;){
        /* insert your main loop code here */
        if ((PIND & 0x40)==0){
            stopIntterupt();
            ILI9325_Initial();
            test_screen();
            spi_vdpenable(1);   //vdp on
            setInttrupt(16667);   //8Mclk 60Hz
        }

    }
    return 0;   /* never reached */
}

void test_screen()
{
    unsigned int i,n,m,k;
    unsigned short color[8]={0xf800,0x07e0,0x001f,0x07ff,0xf81f,0xffe0,0x0000,0xffff};
    unsigned short fc,bc;
    unsigned char *bmpb;
    
    LCD_IndexWrite_ILI9325(0x0022);

     
}

void test_screen2()
{
    unsigned int i,n,m,k;
    unsigned short color[8]={0xf800,0x07e0,0x001f,0x07ff,0xf81f,0xffe0,0x0000,0xffff};
    unsigned short fc,bc;
    
    LCD_IndexWrite_ILI9325(0x0022);

     for (i=0;i<240;i++){
     n=i;
     n=n&7;
     if ((i&15)<2){
     fc=0xffff;bc=0xffff;
     }else{
     fc=0;bc=color[n];
     }
     for(m=0;m<20;m++){
     LCD_DataWrite_ILI9325(fc);
     LCD_DataWrite_ILI9325(fc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     LCD_DataWrite_ILI9325(bc);
     }
     }

}

void psg_init()
{
    int i;
    for(i=0;i<3;i++){
        PSG_COUNT[i]=0;
        PSG_COUNT_TOP[i]=0;
    }
    for(i=0;i<15;i++){
        PSG_REGS[i]=0;
    }
    gNoiseBit=0xffff;
    gNoiseMask=0;
    gToneMask=0;
}

void psg_test()
{
    write_psg(7,31-1-2);
    write_psg(8,15);
    write_psg(9,0);
    write_psg(6,31);
    write_psg(0,gRXSIN);   //O4A
    write_psg(1,1);
    write_psg(2,0xfc);   //O4A
    write_psg(3,0);
    gTest++;
}

//==============================================
void write_psg(byte reg,byte value)
{
}

void spi_init(void) {
    short baud=0;
    //SPI port
    DDR_SPI = (1<<DD_MOSI) | (1<<DD_SCK) | (1<<DD_SS);    //master
    SPCR = (1<<SPE) | (1<<MSTR) | (0<<CPOL) | (0<<SPR0);	//SPI on clk=FSC/2 master
    
    //DDR_SPI=(1<<DD_MISO);   //slave
    //SPCR=(1<<SPE);  //slave
    SPSR |= 1<<SPI2X;
    
    //USART(spi mode)
    UBRR0=0; /*ボーレート設定(クロック停止)*/
    DDRD|=(1<<4); /*XCKnボートピン出力設定 */
    UCSR0C=(1<<UMSEL01)|(1<<UMSEL00)|(0<<UCPHA0)|(0<<UCPOL0);
    /*MSPI,データ種別0設定 */
    UCSR0B=(1<<RXEN0)|(1<<TXEN0); /*送受信許可 */
    UBRR0=baud; /*ボーレート設定 */
    spi_chipselect(0);  //SPARTAN6
    
}

void spi_chipselect(unsigned char chipselect)
{
    PORTC |= 0x03;
    switch (chipselect) {
        case 0:
            //SPARTAN6
            PORTC&=0xFE;
            break;
        case 1:
            //microSD
            PORTC&=0xFD;
            break;
            
        default:
            break;
    }
}
void spi_vdpenable(unsigned char enable)
{
    spi_send(0x20 | (enable?1:0) );
    spi_sendw(0,0);
}

void spi_send(unsigned char value) {
    SPDR=value;
    while (!(SPSR & (1<<SPIF)));
}
unsigned char spi_read(unsigned char value)
{
    SPDR=value;
    while (!(SPSR & (1<<SPIF)));
    return SPDR;
}
unsigned char usartspi_send(unsigned char data) {
    /*送信バッファ空き待機 */
    while(!(UCSR0A&(1<<UDRE0)));
    /*データ送信(送信開始)*/
    UDR0=data;
    /*受信完了待機 */
    while(!(UCSR0A&(1<<RXC0)));
    return UDR0; /*受信データ取得 */
}

void spi_sendw(unsigned char sh,unsigned char sl) {
    SPDR=sh;
    while (!(SPSR & (1<<SPIF)));
    SPDR=sl;
    while (!(SPSR & (1<<SPIF)));
}

void spi_sendNoWait(unsigned char value) {
    //while (!(SPSR & (1<<SPIF)));
    SPDR=value;
}

void setInttrupt(short freq)
{
    //16bit timer setting
    //000000[00] WGMl 1,0
    TCCR1A=0x00;
    //000[0 1][010]  8MHz/8=1MHz
    TCCR1B=0x0A;
    //0000 0010
    TIMSK1=0x02;
    OCR1A=freq; //freq=1MHz/freq
    TCNT1=0;
    sei();	/* enable grobal interrupt */
}

void stopIntterupt()
{
    cli();
    //PORTD &= 0xfe;
    
}

ISR (TIMER1_COMPA_vect)
{
    getKeys();
    spi_send(0x30);
    spi_sendw(Zx,Zx);
    iCounter=1;
}

void getKeys()
{
    byte sh,edge;
    sh=PIND ^ 0x7f;
    //if (((keyedge&0x01)==0)&(sh&0x01)) { mcu_clk_mode^=1;}
    //Zx=(mcu_clk_mode<<1)|((sh & 0x10)>>4);
    // NC-START-1-2-up-right-left-down
    
    Zx=(PIND&0x01)?0x40:0;
    Zx|=(PIND&0x02)?0x10:0;
    Zx|=(PIND&0x04)?0x80:0;
    Zx|=(PIND&0x08)?0x20:0;
    Zx|=(PIND&0x20)?0x01:0;
    Zx|=(PIND&0x10)?0x02:0;
    Zx|=(PIND&0x40)?0x04:0;
    keyedge=sh;
}

//==============================================


void LCD_CtrlWrite_ILI9325(volatile unsigned short index, volatile unsigned short data)
{
    LCD_IndexWrite_ILI9325(index);
    LCD_DataWrite_ILI9325(data);
    return;
}
void LCD_IndexWrite_ILI9325(volatile unsigned short index)
{
    //*(volatile unsigned short*)0x05000000 = index;
    spi_send(0);
    spi_sendw(index>>8,index & 0xff);
    return;
}

void LCD_DataWrite_ILI9325(volatile unsigned short data)
{
    //*(volatile unsigned short*)0x05020000 = data;
    spi_send(1);
    spi_sendw(data>>8,data & 0xff);
    return;
}


void ILI9325_Initial(void)
{
    spi_chipselect(-1);
    spi_chipselect(0);
    spi_vdpenable(0);   //vdp off
    _delay_ms(50);
    
    spi_send(0x11);    //reset off
    spi_sendw(0,0); //dummy
    _delay_ms(10);
    spi_send(0x10);    //reset on
    spi_sendw(0,0); //dummy
    _delay_ms(30);
    spi_send(0x11);    //reset off
    spi_sendw(0,0); //dummy
    _delay_ms(50);
    //************* Start Initial Sequence **********//
    /*
     LCD_CtrlWrite_ILI9325(0x00E3, 0x3008); // Set the internal vcore voltage
     LCD_CtrlWrite_ILI9325(0x00E7, 0x0012); // Set the internal vcore voltage
     LCD_CtrlWrite_ILI9325(0x00EF, 0x1231); // Set the internal vcore voltage
     */
    
    LCD_CtrlWrite_ILI9325(0x0001, 0x0100); // set SS and SM bit
    LCD_CtrlWrite_ILI9325(0x0002, 0x0700); // set 1 line inversion
    //LCD_CtrlWrite_ILI9325(0x0003, 0x1298); // set GRAM write direction and BGR=1.
    LCD_CtrlWrite_ILI9325(0x0003, 0x1030); // set GRAM write direction and BGR=1.
    LCD_CtrlWrite_ILI9325(0x0004, 0x0000); // Resize register
    LCD_CtrlWrite_ILI9325(0x0008, 0x0207); // set the back porch and front porch
    LCD_CtrlWrite_ILI9325(0x0009, 0x0000); // set non-display area refresh cycle ISC[3:0]
    LCD_CtrlWrite_ILI9325(0x000A, 0x0000); // FMARK function
    LCD_CtrlWrite_ILI9325(0x000C, 0x0000); // RGB interface setting
    LCD_CtrlWrite_ILI9325(0x000D, 0x0000); // Frame marker Position
    LCD_CtrlWrite_ILI9325(0x000F, 0x0000); // RGB interface polarity
    //*************Power On sequence ****************//
    LCD_CtrlWrite_ILI9325(0x0010, 0x0000); // SAP, BT[3:0], AP, DSTB, SLP, STB
    LCD_CtrlWrite_ILI9325(0x0011, 0x0007); // DC1[2:0], DC0[2:0], VC[2:0]
    LCD_CtrlWrite_ILI9325(0x0012, 0x0000); // VREG1OUT voltage
    LCD_CtrlWrite_ILI9325(0x0013, 0x0000); // VDV[4:0] for VCOM amplitude
    _delay_ms(200); // Dis-charge capacitor power voltage
    LCD_CtrlWrite_ILI9325(0x0010, 0x1490); // SAP, BT[3:0], AP, DSTB, SLP, STB
    LCD_CtrlWrite_ILI9325(0x0011, 0x0447); // Set DC1[2:0], DC0[2:0], VC[2:0]
    _delay_ms(50); // Delay 50ms
    LCD_CtrlWrite_ILI9325(0x0012, 0x001A); // External reference voltage= Vci;
    _delay_ms(50); // Delay 50ms
    LCD_CtrlWrite_ILI9325(0x0013, 0x1400); // VDV[4:0] for VCOM amplitude
    LCD_CtrlWrite_ILI9325(0x0029, 0x0019); // VCM[5:0] for VCOMH
    LCD_CtrlWrite_ILI9325(0x002B, 0x000B); // Set Frame Rate
    _delay_ms(50); // Delay 50ms
    LCD_CtrlWrite_ILI9325(0x0020, 0x0000); // GRAM horizontal Address
    LCD_CtrlWrite_ILI9325(0x0021, 0x0000); // GRAM Vertical Address
    // ----------- Adjust the Gamma Curve ----------//
    LCD_CtrlWrite_ILI9325(0x0030, 0x0000);
    LCD_CtrlWrite_ILI9325(0x0031, 0x0607);
    LCD_CtrlWrite_ILI9325(0x0032, 0x0305);
    LCD_CtrlWrite_ILI9325(0x0035, 0x0000);
    LCD_CtrlWrite_ILI9325(0x0036, 0x1604);
    LCD_CtrlWrite_ILI9325(0x0037, 0x0204);
    LCD_CtrlWrite_ILI9325(0x0038, 0x0001);
    LCD_CtrlWrite_ILI9325(0x0039, 0x0707);
    LCD_CtrlWrite_ILI9325(0x003C, 0x0000);
    LCD_CtrlWrite_ILI9325(0x003D, 0x000F);
    //------------------ Set GRAM area ---------------//
    LCD_CtrlWrite_ILI9325(0x0050, 0x0000); // Horizontal GRAM Start Address
    LCD_CtrlWrite_ILI9325(0x0051, 0x00EF); // Horizontal GRAM End Address
    LCD_CtrlWrite_ILI9325(0x0052, 0x0000); // Vertical GRAM Start Address
    LCD_CtrlWrite_ILI9325(0x0053, 0x013F); // Vertical GRAM Start Address
    LCD_CtrlWrite_ILI9325(0x0060, 0xA700); // Gate Scan Line
    LCD_CtrlWrite_ILI9325(0x0061, 0x0001); // NDL,VLE, REV
    LCD_CtrlWrite_ILI9325(0x006A, 0x0000); // set scrolling line
    //-------------- Partial Display Control ---------//
    LCD_CtrlWrite_ILI9325(0x0080, 0x0000);
    LCD_CtrlWrite_ILI9325(0x0081, 0x0000);
    LCD_CtrlWrite_ILI9325(0x0082, 0x0000);
    LCD_CtrlWrite_ILI9325(0x0083, 0x0000);
    LCD_CtrlWrite_ILI9325(0x0084, 0x0000);
    LCD_CtrlWrite_ILI9325(0x0085, 0x0000);
    //-------------- Panel Control -------------------//
    LCD_CtrlWrite_ILI9325(0x0090, 0x0010);
    LCD_CtrlWrite_ILI9325(0x0092, 0x0600);
    LCD_CtrlWrite_ILI9325(0x0093, 0x0003);
    LCD_CtrlWrite_ILI9325(0x0095, 0x0110);
    LCD_CtrlWrite_ILI9325(0x0097, 0x0000);
    LCD_CtrlWrite_ILI9325(0x0098, 0x0000);
    LCD_CtrlWrite_ILI9325(0x0007, 0x0133); // 262K color and display ON
}

